#include "types.h"
#ifdef __TRNSFORM
//LOCAL VARIABLES
static UWORD	*Palette15bpp;
static UWORD	*Palette16bpp;
static UBYTE	*Palette24bppRed;
static UBYTE	*Palette24bppGreen;
static UBYTE	*Palette24bppBlue;
static UBYTE	*Palette32bppRed;
static UBYTE	*Palette32bppGreen;
static UBYTE	*Palette32bppBlue;
static UBYTE	*Palette8bpp;
static UBYTE	*PaletteFake;
static UBYTE	*PaletteFakeGreen;
static UBYTE	*PaletteFakeRedBlue;
static UBYTE	*Palette24bpp;
static UBYTE	*Palette32bpp;



//LOCAL FUNCTIONS
/******************************************************************************/
/*	  	    S C A L E    T R A N S F O R M A T I O N S		      */
/******************************************************************************/
static VOID    Scale24(UBYTE *WorkBuffer, UBYTE *ScreenBuffer);
static VOID    Scale16(UBYTE *WorkBuffer, UBYTE *ScreenBuffer);
static VOID    Scale15(UBYTE *WorkBuffer, UBYTE *ScreenBuffer);
static VOID    Scale8(UBYTE *WorkBuffer, UBYTE *ScreenBuffer);

/******************************************************************************/
/*	 	      P A L E T T E    C A L C U L A T I O N S		      */
/******************************************************************************/
static VOID    Calc24to16bppPal(UWORD *Pal24to16); 
static VOID    Calc24to15bppPal(UWORD *Pal24to15);
static VOID    Calc24to8bppPal(UBYTE *Pal24to8);
static VOID    Calc24toFakePal(UBYTE *Pal24toFake);
static VOID    Calc16to32bppPal(UBYTE *Pal16to32Red, UBYTE *Pal16to32Green, UBYTE *Pal16to32Blue);
static VOID    Calc16to24bppPal(UBYTE *Pal16to24Red, UBYTE *Pal16to24Green, UBYTE *Pal16to24Blue);
static VOID    Calc16to15bppPal(UWORD *Pal16to15);
static VOID    Calc16to8bppPal(UBYTE *Pal16to8);
static VOID    Calc16toFakePal(UBYTE *Pal16toFakeRedBlue,UBYTE *Pal16toFakeGreen);
static VOID    Calc15to32bppPal(UBYTE *Pal15to32Red, UBYTE *Pal15to32Green, UBYTE *Pal15to32Blue);
static VOID    Calc15to24bppPal(UBYTE *Pal15to24Red, UBYTE *Pal15to24Green, UBYTE *Pal15to24Blue);
static VOID    Calc15to16bppPal(UWORD *Pal15to16);
static VOID    Calc15to8bppPal(UBYTE *Pal15to8);
static VOID    Calc15toFakePal(UBYTE *Pal15toFakeRedBlue,UBYTE *Pal15toFakeGreen);
static VOID    Calc8to32bppPal(UBYTE *Pal8to32);
static VOID    Calc8to24bppPal(UBYTE *Pal8to24);
static VOID    Calc8to16bppPal(UWORD *Pal8to16);
static VOID    Calc8to15bppPal(UWORD *Pal8to15);

/******************************************************************************/
/*	 	     	    I N I T I A L I Z A T I O N S	              */
/******************************************************************************/
static VOID    Init24to16();
static VOID    Init24to15();
static VOID    Init24to8();
static VOID    Init24toFake();
static VOID    Init16to32();
static VOID    Init16to24();
static VOID    Init16to15();
static VOID    Init16to8();
static VOID    Init16toFake();
static VOID    Init15to32();
static VOID    Init15to24();
static VOID    Init15to16();
static VOID    Init15to8();
static VOID    Init15toFake();
static VOID    Init8to32();
static VOID    Init8to24();
static VOID    Init8to16();
static VOID    Init8to15();
static VOID    End24to32();
static VOID    End24to24();
static VOID    End24to16();
static VOID    End24to15();
static VOID    End24to8();
static VOID    End24toFake();
static VOID    End16to32();
static VOID    End16to24();
static VOID    End16to16();
static VOID    End16to15();
static VOID    End16toFake();
static VOID    End16to8();
static VOID    End15to32();
static VOID    End15to24();
static VOID    End15to16();
static VOID    End15to15();
static VOID    End15to8();
static VOID    End15toFake();
static VOID    End8to32();
static VOID    End8to24();
static VOID    End8to16();
static VOID    End8to15();
static VOID    End8to8();
static VOID    Set320x400();
static VOID    Set320x480();
static VOID    Set640x400();
static VOID    Set640x480();
static VOID    Set80x50();

//IN-LINE FUNCTIONS
VOID    Set_Mode(UWORD Mode);
VOID    Clear_ScreenD(UDWORD size, UDWORD col);
UWORD	FakeMode;
#else
//GLOBAL VARIABLES
extern UWORD	FakeMode;
#endif

//GLOBAL FUNCTIONS
VOID    Transform_bpp(UWORD Workbpp, UWORD Screenbpp, UBYTE *WorkBuffer, UBYTE *ScreenBuffer);
VOID	ReloadPalette();
VOID    InitStuff();

