#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <dos.h>
#include <conio.h>
#include <i86.h>
#include <string.h>
#include <math.h>
#include "vesalint.h"
#include "bitmap.h"
#include "affine.c"
#include "tga.c"

#define  RES_X 320
#define  RES_Y 200
#define  X_LINE 960
#define  MID_X 160
#define  MID_Y 100

#define  ESFERA   0
#define  PLANO    1
#define  CILINDRO 2
#define  PLANO_POLAR 11

#pragma aux Set_Mode=\
"int    10h"\
modify  [ax]\
parm    [ax]

//  rutina para interpolar la imagen para aumentarla
void interpola(unsigned char *pant)
{
    int x,y;
    pant+=3;
    for (y=1;y<MID_Y;y++)
    {
        for (x=1;x<MID_X;x++)
        {
            pant[0]=(pant[-3]+pant[3])>>1;
            pant[1]=(pant[-2]+pant[4])>>1;
            pant[2]=(pant[-1]+pant[5])>>1;
            pant+=6;
        }
        pant+=3;
        for (x=1;x<MID_X;x++)
        {
            pant[0]=(pant[-X_LINE  ]+pant[ X_LINE  ])>>1;
            pant[1]=(pant[-X_LINE+1]+pant[ X_LINE+1])>>1;
            pant[2]=(pant[-X_LINE+2]+pant[ X_LINE+2])>>1;
            pant[3]=(pant[-X_LINE  ]+pant[-X_LINE+6]+pant[X_LINE  ]+pant[X_LINE+6])>>2;
            pant[4]=(pant[-X_LINE+1]+pant[-X_LINE+7]+pant[X_LINE+1]+pant[X_LINE+7])>>2;
            pant[5]=(pant[-X_LINE+2]+pant[-X_LINE+8]+pant[X_LINE+2]+pant[X_LINE+8])>>2;
            pant+=6;
        }    
        pant[0]=(pant[-X_LINE  ]+pant[ X_LINE  ])>>1;
        pant[1]=(pant[-X_LINE+1]+pant[ X_LINE+1])>>1;
        pant[2]=(pant[-X_LINE+2]+pant[ X_LINE+2])>>1;
        pant+=9;
    }
    for (x=1;x<MID_X;x++)
    {
        pant[0]=(pant[-3]+pant[3])>>1;
        pant[1]=(pant[-2]+pant[4])>>1;
        pant[2]=(pant[-1]+pant[5])>>1;
        pant+=6;
    }
}

typedef struct RT_camera
{
    VECTOR pos;
    VECTOR target;
    float roll;
    float d;
}RT_CAMERA;

typedef struct RT_object
{
    int tipo,usa_text,usa_procedural;

    //  Propiedades "fisicas" del objeto

    VECTOR color,color_a,color_b;
    float  brillo,reflex;

    //  Propiedades si el objeto es ESFERA

    VECTOR pos;
    float  radi;

    //  Propiedades si el objeto es PLANO

    VECTOR EjeX,EjeY,EjeZ;
    float  d;

    //  Si el objeto es un cilindro (infinito) utiliza radi, EjeZ y pos

    //  propiedades para texturas

    BITMAP textura;
    float  u_scale,v_scale;

}RT_OBJECT;

typedef struct RT_luz
{
    VECTOR pos;
    VECTOR color;
}RT_LUZ;

typedef struct RT_escena
{
    int num_luz,num_objetos,num_camera;
    int MAX_ITER,RADI_LUZ,LUZ_AMBIENTE,LUZ_DIFUSA,LUZ_ESPECULAR,LUZ_FLARES,INTERPOLA;
    RT_OBJECT objetos[10];
    RT_LUZ    luces[5];
    RT_CAMERA cameras[5];
    VECTOR    ambient;
    
}RT_ESCENA;

void error_dec (int errnum)
{
        getch();
        Set_Mode(0x3);
        printf ("Error %d decoding scene file\n",errnum);
        exit(1);
}

VECTOR lee_vector (FILE *da_file)
{
    char v1[100],v2[100],v3[100];
    VECTOR res;
    fscanf (da_file," %s %s %s\n",v1,v2,v3);
    res.v1=atof(v1);
    res.v2=atof(v2);
    res.v3=atof(v3);
    return (res);
}

float lee_float (FILE *da_file)
{
    char v1[100];
    fscanf (da_file," %s\n",v1);
    return (atof(v1));
}

// rutina para leer las escenas del fichero de texto

void lee_escena (char *name, RT_ESCENA *esc)
{
    FILE *da_file;
    char text[100],text2[100];
    unsigned char *tmp;
    int  signal;

    da_file = fopen (name,"r");

    if (da_file==NULL)
    {
        Set_Mode(0x3);
        printf ("File %s not found!\n",name);
        exit(1);
    }

    signal=0;
    esc->num_objetos=0;  esc->num_camera=0;  esc->num_luz=0;
    esc->ambient.v1=0; esc->ambient.v2=0; esc->ambient.v3=0;
    esc->LUZ_FLARES=0; esc->LUZ_AMBIENTE=1; esc->LUZ_DIFUSA=1; esc->LUZ_ESPECULAR=1;
    esc->INTERPOLA=1;

    while (!signal)
    {
        fscanf(da_file,"%s\n",text);
        if (!strcmp(text,"OBJETO"))
        {
            esc->objetos[esc->num_objetos].usa_text=0;
            esc->objetos[esc->num_objetos].usa_procedural=0;
            while (strcmp(text,"END"))
            {
                fscanf (da_file,"%s :",text);
                if (!strcmp(text,"tipo"))
                {
                    fscanf (da_file," %s\n",text2);
                    if (!strcmp(text2,"PLANO"))esc->objetos[esc->num_objetos].tipo=PLANO;
                    else if (!strcmp(text2,"PLANO_POLAR"))esc->objetos[esc->num_objetos].tipo=PLANO_POLAR;
                    else if (!strcmp(text2,"ESFERA"))esc->objetos[esc->num_objetos].tipo=ESFERA;
                    else if (!strcmp(text2,"CILINDRO"))esc->objetos[esc->num_objetos].tipo=CILINDRO;
                    else error_dec(1);
                }
                else if (!strcmp(text,"pos"))
                    esc->objetos[esc->num_objetos].pos=lee_vector(da_file);
                else if (!strcmp(text,"ejeX"))
                    esc->objetos[esc->num_objetos].EjeX=lee_vector(da_file);
                else if (!strcmp(text,"ejeY"))
                    esc->objetos[esc->num_objetos].EjeY=lee_vector(da_file);
                else if (!strcmp(text,"ejeZ"))
                    esc->objetos[esc->num_objetos].EjeZ=lee_vector(da_file);
                else if (!strcmp(text,"color"))
                    esc->objetos[esc->num_objetos].color=lee_vector(da_file);
                else if (!strcmp(text,"colorA"))
                {
                    esc->objetos[esc->num_objetos].color_a=lee_vector(da_file);
                    esc->objetos[esc->num_objetos].usa_procedural=1;
                }
                else if (!strcmp(text,"colorB"))
                {
                    esc->objetos[esc->num_objetos].color_b=lee_vector(da_file);
                    esc->objetos[esc->num_objetos].usa_procedural=1;
                }
                else if (!strcmp(text,"radio"))
                    esc->objetos[esc->num_objetos].radi=lee_float(da_file);
                else if (!strcmp(text,"d"))
                    esc->objetos[esc->num_objetos].d=lee_float(da_file);
                else if (!strcmp(text,"brillo"))
                    esc->objetos[esc->num_objetos].brillo=lee_float(da_file);
                else if (!strcmp(text,"reflex"))
                    esc->objetos[esc->num_objetos].reflex=lee_float(da_file);
                else if (!strcmp(text,"u_scale"))
                    esc->objetos[esc->num_objetos].u_scale=lee_float(da_file);
                else if (!strcmp(text,"v_scale"))
                    esc->objetos[esc->num_objetos].v_scale=lee_float(da_file);
                else if (!strcmp(text,"textura"))
                {
                    fscanf (da_file," %s\n",text2);
                    GetHDData(text2,&tmp);
                    esc->objetos[esc->num_objetos].textura=ReadTGA(tmp);
                    esc->objetos[esc->num_objetos].usa_text=1;
                    free(tmp);
                }
                else if (strcmp(text,"END")) error_dec(2);
            }
            if (esc->objetos[esc->num_objetos].tipo==PLANO || esc->objetos[esc->num_objetos].tipo==PLANO_POLAR)
                esc->objetos[esc->num_objetos].d=-vtr_dot_mul_vtr(
                                                   esc->objetos[esc->num_objetos].EjeZ,
                                                   esc->objetos[esc->num_objetos].pos);
            esc->num_objetos++;
            fscanf(da_file," %s\n",text);
            if (strcmp(text,"OBJETO")) error_dec(10);
            text[0]='\0';
        }
        else if (!strcmp(text,"CAMARA"))
        {
            while (strcmp(text,"END"))
            {
                fscanf (da_file,"%s :",text);
                if (!strcmp(text,"pos"))
                    esc->cameras[esc->num_camera].pos=lee_vector(da_file);
                else if (!strcmp(text,"target"))
                    esc->cameras[esc->num_camera].target=lee_vector(da_file);
                else if (!strcmp(text,"roll"))
                    esc->cameras[esc->num_camera].roll=lee_float(da_file);
                else if (!strcmp(text,"focus"))
                    esc->cameras[esc->num_camera].d=lee_float(da_file);
                else if (strcmp(text,"END")) error_dec(3);
            }
            esc->num_camera++;
            fscanf(da_file," %s\n",text);
            if (strcmp(text,"CAMARA")) error_dec(10);
            text[0]='\0';
        }
        else if (!strcmp(text,"LUZ"))
        {
            while (strcmp(text,"END"))
            {
                fscanf (da_file,"%s :",text);
                if (!strcmp(text,"pos"))
                    esc->luces[esc->num_luz].pos=lee_vector(da_file);
                else if (!strcmp(text,"color"))
                    esc->luces[esc->num_luz].color=lee_vector(da_file);
                else if (strcmp(text,"END")) error_dec(4);
            }
            esc->num_luz++;
            fscanf(da_file," %s\n",text);
            if (strcmp(text,"LUZ")) error_dec(10);
            text[0]='\0';
        }
        else if (!strcmp(text,"GLOBAL"))
        {
            while (strcmp(text,"END"))
            {
                fscanf (da_file,"%s :",text);
                if (!strcmp(text,"ambient"))
                    esc->ambient=lee_vector(da_file);
                else if (!strcmp(text,"luz_radio"))
                    esc->RADI_LUZ=lee_float(da_file);
                else if (!strcmp(text,"luz_ambiente"))
                    esc->LUZ_AMBIENTE=lee_float(da_file);
                else if (!strcmp(text,"luz_difusa"))
                    esc->LUZ_DIFUSA=lee_float(da_file);
                else if (!strcmp(text,"luz_especular"))
                    esc->LUZ_ESPECULAR=lee_float(da_file);
                else if (!strcmp(text,"interpola"))
                    esc->INTERPOLA=lee_float(da_file);
                else if (!strcmp(text,"luz_flares"))
                    esc->LUZ_FLARES=lee_float(da_file);
                else if (!strcmp(text,"iteraciones"))
                    esc->MAX_ITER=lee_float(da_file);
                else if (strcmp(text,"END")) error_dec(4);
            }
            fscanf(da_file," %s\n",text);
            if (strcmp(text,"GLOBAL")) error_dec(10);
            text[0]='\0';
        }
        else signal=1;
    }
    fclose (da_file);
}

VECTOR get_normal (RT_OBJECT *objeto, VECTOR pos)
{
    VECTOR normal;
    float upos,vpos,wpos;
    int   tpos;
    switch (objeto->tipo)
    {
        case ESFERA :
             normal=mul_vtr(1/objeto->radi,vtr_sub_vtr(pos,objeto->pos));
             if (objeto->usa_text)
             {
                 upos=objeto->u_scale*atan2(vtr_dot_mul_vtr(normal,objeto->EjeY),
                                            vtr_dot_mul_vtr(normal,objeto->EjeX))/(2*pi);
                 vpos=objeto->v_scale*acos(min(1.0,max(-1.0,vtr_dot_mul_vtr(normal,objeto->EjeZ))))/pi;
             }
        break;
        case PLANO :
             if (objeto->usa_text)
             {
                 normal=vtr_sub_vtr(pos,objeto->pos);
                 upos=vtr_dot_mul_vtr(normal,objeto->EjeX)*objeto->u_scale;
                 vpos=vtr_dot_mul_vtr(normal,objeto->EjeY)*objeto->v_scale;
             }
             normal=objeto->EjeZ;
        break;
        case PLANO_POLAR :
             if (objeto->usa_text)
             {
                 normal=vtr_sub_vtr(pos,objeto->pos);
                 upos=objeto->u_scale*atan2(vtr_dot_mul_vtr(normal,objeto->EjeY),
                                            vtr_dot_mul_vtr(normal,objeto->EjeX))/(2*pi);
                 vpos=mod_vtr(normal)*objeto->v_scale;
             }
             normal=objeto->EjeZ;
        break;
        case CILINDRO:
             normal=vtr_sub_vtr(pos,objeto->pos);
             vpos=vtr_dot_mul_vtr(normal,objeto->EjeZ);
             normal=mul_vtr(1/objeto->radi,vtr_sub_vtr(normal,mul_vtr(vpos,objeto->EjeZ)));
             if (objeto->usa_text)
             {
                 upos=objeto->u_scale*atan2(vtr_dot_mul_vtr(normal,objeto->EjeY),
                                            vtr_dot_mul_vtr(normal,objeto->EjeX))/(2*pi);
                 vpos*=objeto->v_scale;
             }
        break;
    }
    
    if (objeto->usa_procedural)
    {
         upos=pos.v1*0.005-floor(pos.v1*0.005);
         vpos=pos.v2*0.005-floor(pos.v2*0.005);
         wpos=pos.v3*0.005-floor(pos.v3*0.005);
         if ((upos>=0.5) ^ (vpos>=0.5)^ (wpos>=0.5))
             objeto->color=objeto->color_b;
         else 
             objeto->color=objeto->color_a;
    }
    else if (objeto->usa_text)
    {
        upos=(upos-floor(upos))*objeto->textura.Width;
        vpos=(vpos-floor(vpos))*objeto->textura.Height;
        tpos=3*(((int)upos)+((int)vpos)*objeto->textura.Width);
        objeto->color.v1=((float)objeto->textura.Src[tpos+2]);
        objeto->color.v2=((float)objeto->textura.Src[tpos+1]);
        objeto->color.v3=((float)objeto->textura.Src[tpos]);
    }
    return normal;
}

float get_intersect (RT_OBJECT *objeto, VECTOR ori_rayo, VECTOR dir_rayo)
{
    VECTOR v_calc;
    float  bpart,disc,disc2;
    
    float  t,t1,t2;
    switch (objeto->tipo)
    {
        case ESFERA :
             v_calc=vtr_sub_vtr(objeto->pos,ori_rayo);
             bpart=vtr_dot_mul_vtr  (v_calc,dir_rayo);
             disc=bpart*bpart-mod_vtr2(v_calc)+objeto->radi*objeto->radi;
             if (disc>0)
             {
                 disc=sqrt(disc);
                 t1=bpart-disc;
                 t2=bpart+disc;
                 if (t2>t1) t=t1;
                 else t=t2;
             }
             else t=-1;
             break;
         case PLANO :
              disc=vtr_dot_mul_vtr (objeto->EjeZ,dir_rayo);
              if (disc!=0)
              {
                  t=-(vtr_dot_mul_vtr (objeto->EjeZ,ori_rayo)+objeto->d)/disc;
              }
              else t=-1;
              break;
         case PLANO_POLAR :
              disc=vtr_dot_mul_vtr (objeto->EjeZ,dir_rayo);
              if (disc!=0)
              {
                  t=-(vtr_dot_mul_vtr (objeto->EjeZ,ori_rayo)+objeto->d)/disc;
              }
              else t=-1;
              break;

         case CILINDRO :
             dir_rayo=vtr_sub_vtr(dir_rayo,mul_vtr(vtr_dot_mul_vtr(dir_rayo,objeto->EjeZ),objeto->EjeZ));
             disc2=mod_vtr2(dir_rayo);
             if (disc2!=0)
             {
                 v_calc=vtr_sub_vtr(ori_rayo,objeto->pos);
                 v_calc=vtr_sub_vtr(v_calc,mul_vtr(vtr_dot_mul_vtr(v_calc,objeto->EjeZ),objeto->EjeZ));
                 bpart=vtr_dot_mul_vtr  (v_calc,dir_rayo);
                 disc=bpart*bpart+(objeto->radi*objeto->radi-mod_vtr2(v_calc))*disc2;
                 if (disc>0)
                 {
                     disc=sqrt(disc);
                     disc2=1/disc2;
                     t1=(-bpart+disc)*disc2;
                     t2=(-bpart-disc)*disc2;
                     if (t2>t1) t=t1;
                     else t=t2;
                 }
                 else t=-1;
             }
             else t=-1;
             break;
    }
    return t;
}    

int  rayo_sombra(RT_ESCENA *esc, VECTOR origen, VECTOR rayo, float max_t,int ori_object)
{
    float  t;
    int    sc;
    for (sc=0;sc<esc->num_objetos;sc++)
    if  (sc!=ori_object)
    {
            t=get_intersect(&esc->objetos[sc],origen,rayo);
            if ((t>0)&&(t<max_t)) return 1;
    }
    return 0;
}

VECTOR rayo_luz (RT_ESCENA *esc, VECTOR origen, VECTOR ray, int iter, int ori_object)
{
        int    sc,lc,min_object;
        float  bpart,disc,t,min_t,cos_alfa,cos_beta,brillo,mod_luz;
        VECTOR posicion,normal,v_luz,color,add_col,col_ref,ray_ref;
        VECTOR zero_color={0,0,0};
        VECTOR v_calc;
    
        min_t=1000000.0;
        min_object=-1;
        for (sc=0;sc<esc->num_objetos;sc++)
        if  (sc!=ori_object)
        {
             t=get_intersect(&esc->objetos[sc],origen,ray);
             if ((t>0)&&(t<min_t)) {min_t=t; min_object=sc;}
        }
        if (min_object>=0)      // Si el rayo da con alguna esfera...
        {
            posicion=vtr_add_vtr(origen,mul_vtr(min_t,ray));
            normal=get_normal(&esc->objetos[min_object],posicion);
            ray_ref=vtr_sub_vtr(ray,mul_vtr(2*vtr_dot_mul_vtr(ray,normal),normal));
            if (esc->LUZ_AMBIENTE)
                color=vtr_dir_mul_vtr(esc->objetos[min_object].color,esc->ambient);
            else
                color=zero_color;
            for (lc=0;lc<esc->num_luz;lc++)
            {
                v_luz=vtr_sub_vtr(esc->luces[lc].pos,posicion);
                mod_luz=mod_vtr(v_luz);                 //esta es la distancia a la que se encuentra la luz
                v_luz=mul_vtr(1/mod_luz,v_luz);
                cos_alfa=vtr_dot_mul_vtr(v_luz,normal);
                if (cos_alfa>0)
                    if (!rayo_sombra(esc,posicion,v_luz,mod_luz,min_object))
                    {   

                        cos_beta=vtr_dot_mul_vtr(ray_ref,v_luz);
                        brillo=0;
                        if (cos_beta>0 && esc->LUZ_ESPECULAR)
                            brillo+=exp(esc->objetos[min_object].brillo*(cos_beta-1));
                        if (esc->LUZ_DIFUSA)
                            brillo+=cos_alfa;
                        add_col=mul_vtr(brillo,esc->objetos[min_object].color);
                        add_col=vtr_dir_mul_vtr(esc->luces[lc].color,add_col);
                        color=vtr_add_vtr(color,add_col);
                    }
            }
            // si hace falta, se lanza un rayo reflejado
            if (iter<esc->MAX_ITER){
            col_ref=rayo_luz(esc,posicion,ray_ref,iter+1,min_object);
            color=vtr_add_vtr(mul_vtr(esc->objetos[min_object].reflex,col_ref),
                              mul_vtr(1-esc->objetos[min_object].reflex,color));}
        }
        else if (esc->LUZ_AMBIENTE) color=mul_vtr(255,esc->ambient);
            else color=zero_color;

        // Calculos para representar las luces
        if (iter==0 && esc->LUZ_FLARES)
        for (lc=0;lc<esc->num_luz;lc++)
        {
            v_calc=vtr_sub_vtr(esc->luces[lc].pos,origen);
            bpart=vtr_dot_mul_vtr (v_calc,ray);
            disc=bpart*bpart-mod_vtr2(v_calc)+esc->RADI_LUZ*esc->RADI_LUZ;
            if ((disc>0)&&(bpart>0.1)&&(bpart<min_t))
            {
                disc=sqrt(disc);
                color=vtr_add_vtr(color,mul_vtr(disc*255/esc->RADI_LUZ,esc->luces[lc].color));
            }
        }
        
        return (color);
}

void RT_render(RT_ESCENA *esc, unsigned char *dest)
{
    int xc,yc,ppos;
    VECTOR v_col,origen,direccion,v_dir;

    VECTOR X_axe, Y_axe, Z_axe;
    VECTOR X_axep, Y_axep;
    VECTOR right = {1.0,0.0,0.0};
    VECTOR down  = {0.0,1.0,0.0};
    VECTOR deep  = {0.0,0.0,-1.0};
    float  angle;

    // Calculamos el sistema de ejes para la camara

    Z_axe=unit_vtr(vtr_sub_vtr(esc->cameras->target,esc->cameras->pos));
    angle=vtr_dot_mul_vtr(Z_axe,down);
    if ((angle<1.0)&&(angle>-1.0))
    {
        X_axe=unit_vtr(vtr_cross_mul_vtr(down,Z_axe));
        Y_axe=unit_vtr(vtr_cross_mul_vtr(Z_axe,X_axe));
    }
    else    
    {
        X_axe=right;
        Y_axe=deep;
    }

    X_axep=mul_vtr(cos(esc->cameras->roll),X_axe);
    Y_axep=mul_vtr(sin(esc->cameras->roll),Y_axe);
    X_axep=vtr_add_vtr(X_axep,Y_axep);
    X_axe=mul_vtr(-sin(esc->cameras->roll),X_axe);
    Y_axe=mul_vtr(cos(esc->cameras->roll),Y_axe);
    Y_axep=vtr_add_vtr(X_axe,Y_axe);

    // Lanzamos los rayos utilizando los ejes de la camara

    origen=esc->cameras->pos;
    v_dir=vtr_add_vtr(mul_vtr(-MID_Y,Y_axep),mul_vtr(-MID_X,X_axep));
    v_dir=vtr_add_vtr(v_dir,mul_vtr(esc->cameras->d,Z_axe));

    ppos=0;

    if (esc->INTERPOLA)
    {
        for (yc=-MID_Y;yc<MID_Y;yc+=2)
        {
            for (xc=-MID_X;xc<MID_X;xc+=2)
            {
                direccion=unit_vtr(v_dir);
                v_dir=vtr_add_vtr(mul_vtr(2,X_axep),v_dir);
                v_col=rayo_luz(esc,origen,direccion,0,-1);
    
                dest[ppos  ]=min(v_col.v3,254);
                dest[ppos+1]=min(v_col.v2,254);
                dest[ppos+2]=min(v_col.v1,254);
        
                ppos+=6;
            }
          v_dir=vtr_add_vtr(v_dir,mul_vtr(-RES_X,X_axep));
          v_dir=vtr_add_vtr(mul_vtr(2,Y_axep),v_dir);
          ppos+=X_LINE;
        }   
        interpola(dest);
    }
    else
    {
        for (yc=-MID_Y;yc<MID_Y;yc++)
        {
            for (xc=-MID_X;xc<MID_X;xc++)
            {
                direccion=unit_vtr(v_dir);
                v_dir=vtr_add_vtr(X_axep,v_dir);
                v_col=rayo_luz(esc,origen,direccion,0,-1);
    
                dest[ppos  ]=min(v_col.v3,254);
                dest[ppos+1]=min(v_col.v2,254);
                dest[ppos+2]=min(v_col.v1,254);
        
                ppos+=3;
            }
          v_dir=vtr_add_vtr(v_dir,mul_vtr(-RES_X,X_axep));
          v_dir=vtr_add_vtr(Y_axep,v_dir);
        }   
    }
}

RT_ESCENA *ray_testing;
unsigned char *Virtpant1;
unsigned char *Virtpant2;

void main(int argc, char *argv[])
{
    float movi=0;
    int   c;

    Virtpant1=malloc(RES_X*RES_Y*3);
    Virtpant2=malloc(RES_X*RES_Y*3);
    for (c=0;c<RES_X*RES_Y*3;c++)
    Virtpant1[c]=0;

    // Definiciones de los objetos, luces y camara de la escena        

    ray_testing=malloc(sizeof(RT_ESCENA));
    if (argc>1)
        lee_escena (argv[1],ray_testing);
    else
        lee_escena ("test.ray",ray_testing);

    Active.Screen.Width=320;
    Active.Screen.Height=200;
    Active.Screen.bpp=32;

    Active.Work.Width=RES_X;
    Active.Work.Height=RES_Y;
    Active.Work.bpp=24;

    Active.EnableLFB=1;

    if (!InitSetMode())
    {
        Active.Screen.bpp=24;
        if (!InitSetMode())
        {
            Active.Screen.bpp=16;
            if (!InitSetMode())
            {
                Active.Screen.bpp=15;
                if (!InitSetMode())
                {
                    Active.Screen.bpp=-1;
                    Active.Screen.Height*=2;
                    InitSetMode();
                }
            }
        }
    }

    movi=0;
    while (!kbhit())
    {
        // Calculos para "animar" los elementos de la escena
        
        ray_testing->cameras[0].pos.v1=800*sin(movi/80.0);
        ray_testing->cameras[0].pos.v2=-200*(1-cos(movi/40.0));
        ray_testing->cameras[0].pos.v3=1000*(1-cos(movi/80.0));
        ray_testing->cameras[0].roll=0.5*sin(movi/20.0);
        movi++;

        RT_render(ray_testing,Virtpant1);
        Flip(Virtpant1);
    }
    getch();
    Set_Mode(0x3);
    Free_Memory();
    printf("[#] Salio\n");
}


