//  Persistance of Vision Raytracer V3.1
//  World definition file.
//
//  Contains 1 lights, 46 materials and 19 primitives.
//
//  This file was generated for POV-Ray V3.1 by
//  Moray V3.1 For Windows (c) 1991-1998 Lutz + Kretzschmar
//

//  Date : 12/20/1999    (20.12.1999)
//

/*
  The text between these two comments is in MorayPOV.INC and is
  automatically included in all POV files that Moray exports.
*/

default {
  texture {
    pigment { rgb <1,0,0> }
  }
}

/* // Scene Comment

This scene was created with Moray V3.1 For Windows.

*/ // End Scene Comment

global_settings {
  adc_bailout 0.003922
  ambient_light <1.0,1.0,1.0>
  assumed_gamma 1.9
  hf_gray_16 off
  irid_wavelength <0.247059,0.176471,0.137255>
  max_intersections 64
  max_trace_level 10
  number_of_waves 10
  radiosity {
    brightness       3.3
    count            100
    distance_maximum 0.0
    error_bound      0.4
    gray_threshold   0.5
    low_error_factor 0.8
    minimum_reuse    0.015
    nearest_count    6
    recursion_limit  1
  }
}

background { color <0.000,0.000,0.000> }

camera {  //  Camera Camera01
  location  <     -5.111,     -10.042,       5.000>
  direction <        0.0,         0.0,      2.4880> // Aperture is 0.40 degrees
  sky       <    0.00000,     0.00000,     1.00000> // Use right handed-system 
  up        <        0.0,         0.0,         1.0> // Where Z is up
  right     <    1.33333,         0.0,         0.0> // Aspect ratio
  look_at   <      0.753,      -0.151,       1.000>
}

//    Other cameras are commented out.
/*
camera {  //  Camera SpotCam001
  location  <      0.000,      -0.100,       0.000>
  direction <        0.0,         0.0,      1.8660> // Aperture is 0.52 degrees
  sky       <    0.00000,     0.00000,     1.00000> // Use right handed-system 
  up        <        0.0,         0.0,         1.0> // Where Z is up
  right     <    1.33333,         0.0,         0.0> // Aspect ratio
  look_at   <      0.000,       0.000,       0.000>
}

*/

//
// *******  L I G H T S *******
//

light_source {   // Light001
  <-1.724, -9.030, 7.866>
  color rgb <1.000, 1.000, 1.000>
}


//
// ********  MATERIALS  *******
//

#include "pcmania.inc"


//
// ********  REFERENCED OBJECTS  *******
//



//
// ********  OBJECTS  *******
//

superellipsoid { // SuperQ008
  <1.0, 0.1>
  material {
    T_Old_Glass
  }
  scale -0.426176
  translate  <3.284724, 4.139653, 0.42843>
}


cone { // Cone001
  <0,0,0>, 0.0, <0,0,1>, 1.0
  material {
    T_Old_Glass
  }
  scale <0.128293, 0.113458, 0.899731>
  rotate <0.0, -180.0, -180.0>
  translate  <2.267177, -2.764123, 0.904175>
}


torus { // Torus001
  1.5, 0.5  rotate -x*90
  material {
    T_Old_Glass
  }
  scale -0.259894
  translate  <-0.497724, -2.159819, 0.138285>
}


sphere { // Sphere006
  <0,0,0>,1
  material {
    T_Old_Glass
  }
  scale 0.074913
  translate  <-2.233353, -1.098192, 0.116442>
}


sphere { // Sphere001
  <0,0,0>,1
  material {
    T_Old_Glass
  }
  scale 0.383275
  translate  <2.415933, -1.952748, 0.462544>
}


plane { // Plane001
  z,0
  material {
    Aluminum
  }
}


superellipsoid { // SuperQ001
  <0.1, 0.1>
  material {
    T_Old_Glass
  }
  scale <0.338595, -0.288455, 1.872905>
  translate  <-1.619869, -1.68863, 1.87227>
}




text {   // TText001
  ttf    "C:\WINDOWS\Fonts\Snap____.ttf",
  "PC-Mania",
  0.5,  // Depth
  <0.0,   0.0, 0.0> // Offset
  material {
    Gold_Nugget_1
  }
  scale 0.630736
  rotate <-90.0, -180.0, 120.403648>
  translate  0.129437*z
}



superellipsoid { // SuperQ002
  <0.1, 0.1>
  material {
    T_Old_Glass
  }
  scale <0.338595, -0.288455, 1.872905>
  translate  <3.764492, -1.65098, 1.854489>
}


superellipsoid { // SuperQ003
  <0.1, 0.1>
  material {
    T_Old_Glass
  }
  scale <0.338595, -0.288455, 1.872905>
  translate  <-1.683899, 2.354099, 1.87227>
}


superellipsoid { // SuperQ004
  <0.1, 0.1>
  material {
    T_Old_Glass
  }
  scale <0.338595, -0.288455, 1.872905>
  translate  <0.938046, 2.283709, 1.87227>
}


superellipsoid { // SuperQ005
  <0.1, 0.1>
  material {
    T_Old_Glass
  }
  scale <0.338595, -0.288455, 1.872905>
  translate  <3.732249, 2.326697, 1.87227>
}


superellipsoid { // SuperQ006
  <0.1, 0.1>
  material {
    T_Old_Glass
  }
  scale <0.338595, -0.288455, 1.872905>
  translate  <-1.770472, 0.005651, 1.87227>
}


superellipsoid { // SuperQ007
  <0.1, 0.1>
  material {
    T_Old_Glass
  }
  scale <0.338595, -0.288455, 1.872905>
  translate  <3.726531, 0.080953, 1.87227>
}


sphere { // Sphere002
  <0,0,0>,1
  material {
    T_Old_Glass
  }
  scale 0.383275
  translate  <1.740989, 1.106995, 0.462544>
}


sphere { // Sphere004
  <0,0,0>,1
  material {
    T_Old_Glass
  }
  scale 0.074913
  translate  <1.366345, -3.527989, 0.116442>
}


sphere { // Sphere005
  <0,0,0>,1
  material {
    T_Old_Glass
  }
  scale 0.074913
  translate  <3.031205, 0.611664, 0.116442>
}


sphere { // Sphere007
  <0,0,0>,1
  material {
    T_Old_Glass
  }
  scale 0.074913
  translate  <0.451781, -3.067996, 0.116442>
}


