#include "macros.inc"
#include "colors.inc"

camera{location<-500,1000,-500> look_at<2500,500,2500>}
light_source{<-100000,100000,-100000> White shadowless}
light_source{<100000,100000,-100000> White}


// La semilla
#declare R=seed(8213)

#declare fichTXT="PruebaA.txt"
#declare fichTGA="PruebaA.tga"
cargaTXT(fichTXT)

#declare escalaHF_X=5000;     //Escala en X para el HF
#declare escalaHF_Z=5000;     //Escala en Z para el HF
#declare escalaHF_Y=500;     //Escala en Y para el HF
#declare razonX=escalaHF_X/anchoHF;
#declare razonZ=escalaHF_Z/altoHF;

height_field{
   tga fichTGA
   pigment{rgb <186/255,125/255,81/255>}
   smooth
   scale<escalaHF_X,escalaHF_Y,escalaHF_Z>
}



//
// Ahora un par de objetos de ejemplos
//



// Un punto de ejemplo, en el centro del HF
#declare xpos=escalaHF_X/2;
#declare zpos=escalaHF_Z/2;
#declare ind_i=int(zpos/razonZ);
#declare ind_j=int(xpos/razonX);
#declare altura=(datosHF[ind_i][ind_j]/65535)*escalaHF_Y;

sphere{0 100 pigment{Blue} translate <xpos,altura,zpos>}



// Un bucle de ejemplo
#declare i=0;
#while (i<5)
   #declare j=0;
   #while (j<10)
      #declare xpos=(i*200)+500;
      #declare zpos=(j*200)+500;
      #declare ind_i=int(zpos/razonZ);
      #declare ind_j=int(xpos/razonX);
      #declare altura=(datosHF[ind_i][ind_j]/65535)*escalaHF_Y;
      sphere{0 50 pigment{Red} translate <xpos,altura,zpos>}
      #declare j=j+1
   #end
   #declare i=i+1
#end