#include "macros.inc"
#include "colors.inc"
#include "woods.inc"
#include "stones.inc"
#include "metals.inc"
#include "skies.inc"


// La semilla
#declare R=seed(8213)

#declare zombi=1;
#declare caballero=2;
#declare evormiga=3;
#declare orco=4;
#debug "\nEmpezamos a cargar mallas.\n"
#include "piezor.inc"
#include "piezhu.inc"
#debug "Se acabaron la mallas.\n"
//#include "piezes.inc"
//#include "piezev.inc"

#debug "Cargamos el TXT y colocamos el HF.\n"
#declare fichTXT="HF_B100.txt"
#declare fichTGA="HF_B.tga"
cargaTXT(fichTXT)
#declare nfilas=20;        //N de filas del doble bucle
#declare ncolum=20;        //N de columnas del doble bucle
#declare separacion=400;   //Separacion entre cada paso del bucle
#declare escalaHF_Y=800;   //Escala en Y para el HF
#declare escalaHF_X=ncolum*separacion;
#declare escalaHF_Z=nfilas*separacion;
#declare razonX=escalaHF_X/anchoHF;
#declare razonZ=escalaHF_Z/altoHF;
height_field{
   tga fichTGA
   pigment{rgb <186/255,125/255,81/255>}
   smooth
   scale<escalaHF_X,escalaHF_Y,escalaHF_Z>}

#debug "TXT cargado y HF colocado.\n"
//
// El bucle empieza en 1 y no en 0, porque al aplicar ruido a la posicion del objeto
// en el primer paso del bucle, puede salir una posicion negativa,
// por lo que su correspondiente indice en el array seria negativo tambien,
// lo cual no es factible.
// Termina en nfilas-1 (nunca llega a nfilas) por la misma razon, es decir, si terminara
// en nfilas el ruido (en este caso positivo) podria dar una posicion, que al hallar su
// indice en el array se saliese del rango de este.
//
#debug "Comienza el bucle.\n"
#declare i=1;
#while (i<nfilas)
	#declare j=1;
	#while (j<ncolum)
		//La posicion XZ del objeto a colocar
		#declare xpos=(j*separacion)+aleatorio(-200,200)
		#declare zpos=(i*separacion)+aleatorio(-200,200)
		//Su indice mejor aproximado en el array
		#declare ind_i=int(zpos/razonZ);
		#declare ind_j=int(xpos/razonX);
		
		
		//	Estos valores nos ayudan a interpolar,
		// para rotar a los objetos segun la inclinacion del terreno.
		// Tomamos unos valores adyacentes separados un distancia dist_aux,
		// y formamos dos triangulos rectangulos(uno para cada eje (X,Z)),
		// le hallamos la pendiente y este es el angulo que rotamos al objeto.
		// Una pequea chapucilla, pero da el pego.
		#declare dist_aux=150;
		#declare xpos_aux1=xpos+dist_aux;
		#declare xpos_aux2=xpos-dist_aux;
		#declare zpos_aux1=zpos+dist_aux;
		#declare zpos_aux2=zpos-dist_aux;
				
		#declare ind_aux1=int(xpos_aux1/razonX);
		#declare ind_aux2=int(xpos_aux2/razonX);
		#declare ind_aux3=int(zpos_aux1/razonZ);
		#declare ind_aux4=int(zpos_aux2/razonZ);
		
		#declare aux1=datosHF[ind_i][ind_aux1]*escalaHF_Y/65536;
		#declare aux2=datosHF[ind_i][ind_aux2]*escalaHF_Y/65536;
		#declare aux3=aux1-aux2;
		#declare aux4=datosHF[ind_aux3][ind_j]*escalaHF_Y/65536;
		#declare aux5=datosHF[ind_aux4][ind_j]*escalaHF_Y/65536;
		#declare aux6=aux4-aux5;


		
		//
		// Un objeto de prueba:
		// Una pelota roja con un palo azul hacia arriba.
		//
		/*union{
			sphere{0 30 pigment{Red}}
			cylinder{0 y*100 15 pigment{Blue}}
			rotate x*-degrees(atan2(aux6,dist_aux*2))
			rotate z*degrees(atan2(aux3,dist_aux*2))
			translate <xpos,escalaHF_Y*datosHF[ind_i][ind_j]/65535,zpos>
		}*/


				
		//
		//Los objetos y personajes.
		//
		#if (rand(R)<0.9)
			#switch (int(rand(R)*5))
				#range (0,1)	//	Cosas relativas al orco
					object{#include "switch0.inc"
						rotate x*-degrees(atan2(aux6,dist_aux*2))
						rotate z*degrees(atan2(aux3,dist_aux*2))
						translate <xpos,escalaHF_Y*datosHF[ind_i][ind_j]/65535,zpos>
					}
				#break
				#range (2,3)	//	Cosas relativas al humano
					object{#include "switch1.inc"
						rotate x*-degrees(atan2(aux6,dist_aux*2))
						rotate z*degrees(atan2(aux3,dist_aux*2))
						translate <xpos,escalaHF_Y*datosHF[ind_i][ind_j]/65535,zpos>
					}
				#break
				#case (4)	//	Cosas generales
					object{#include "switch2.inc"
						rotate x*-degrees(atan2(aux6,dist_aux*2))
						rotate z*degrees(atan2(aux3,dist_aux*2))
						translate <xpos,escalaHF_Y*datosHF[ind_i][ind_j]/65535,zpos>
					}
				#break
			#end
		#end
		
		#declare j=j+1;
	#end
	#declare i=i+1;
#end
#debug "Se acaba el bucle.\n"



//
//	Vamos a colocar la camara "dentro" del HF
//
#declare cam_loc_X=(450*(separacion*ncolum))/1024;
#declare cam_loc_Z=((1024-750)*(separacion*nfilas))/1024;
#declare cam_look_X=((450)*(separacion*ncolum))/1024;
#declare cam_look_Z=((1024-400)*(separacion*nfilas))/1024;

#declare cam_loc_ind_i=int(cam_loc_Z/razonZ)
#declare cam_loc_ind_j=int(cam_loc_X/razonX)
#declare cam_look_ind_i=int(cam_look_Z/razonZ)
#declare cam_look_ind_j=int(cam_look_X/razonX)


camera {
location <cam_loc_X,(escalaHF_Y*datosHF[cam_loc_ind_i][cam_loc_ind_j]/65536)+200,cam_loc_Z>
look_at <cam_look_X,(escalaHF_Y*datosHF[cam_look_ind_i][cam_look_ind_j]/65536)+200,cam_look_Z>
}
light_source { <100000,100000,-100000> White }
sky_sphere { S_Cloud4 rotate y*-300 }
