//
//	Este fichero define varias macros de uso bastante general.
//	Por: Manuel Mata Rueda.
//	



//
//	Una macro que da un numero aleatorio entre dos enteros,
//	ambos inclusive.
// Los parametros son enteros.
//
#macro aleatorio(a,b)
	#if (a<b)
		int((rand(R)*(b-a+2))+a-1)
	#else
		int((rand(R)*(a-b+2))+b-1)
	#end
#end



//
//	Una macro que crea un vector ruido.
//	Suelo usarla mucho para crear pequeas variaciones en las traslaciones.
//	Ojo que solo sirve para numeros enteros, aunque variandolo sirve para numeros reales.
// Los dos parametros son vectores.
//
#macro ruido(rango,signo)
	//Calculamos el rango aleatoriamente
	#local rango_aleatx=int(rand(R)*rango.x);
	#local rango_aleaty=int(rand(R)*rango.y);
	#local rango_aleatz=int(rand(R)*rango.z);

	#local signo_aleatx=signo.x;
	#local signo_aleaty=signo.y;
	#local signo_aleatz=signo.z;
	
	//El signo aleatoriamente, solo cuando el valor en el eje
	//correspondiente sea cero
	#if (signo_aleatx=0)
		#if (rand(R)>0.5) #local signo_aleatx=1;
		#else #local signo_aleatx=-1;
		#end
	#end
	#if (signo_aleaty=0)
		#if (rand(R)>0.5) #local signo_aleaty=1;
		#else #local signo_aleaty=-1;
		#end
	#end
	#if (signo_aleatz=0)
		#if (rand(R)>0.5) #local signo_aleatz=1;
		#else #local signo_aleatz=-1;
		#end
	#end
	
	<rango_aleatx*signo_aleatx,rango_aleaty*signo_aleaty,rango_aleatz*signo_aleatz>
#end



//
//	Una macro que carga los valores de un height_field en dos arrays.
// Declara dos variables globales: anchoHF y altoHF.
//	Los arrays son: cabeceraHF y datosHF.
// El parametro es una cadena de caracteres.
//
#macro cargaTXT(f)
   
   #fopen fichero f read
	
	#declare cabeceraHF=array[54]
	
	#local i=0;
	#while (i<54)
		#read(fichero,aux)
		#declare cabeceraHF[i]=aux;
		#local i=i+1;
	#end
	
	#declare anchoHF=cabeceraHF[18]+(cabeceraHF[19]*256);
	#declare altoHF=cabeceraHF[22]+(cabeceraHF[23]*256);
	
	
	//
	// Un par de bucles para leer los datos del Height Field
	//
	
	
	//
	//datosHF[0][0] es la esquina superior izquierda del height field
	//datosHF[altoHF][anchoHF]	es la esquina inferior derecha del height field
	//
	/*#declare datosHF=array[altoHF][anchoHF]
	#local j=altoHF-1;
	#while (j>=0)
		#local i=0;
		#while (i<anchoHF)
			#read(fichero,BLUE,GREEN,RED)
			#declare datosHF[j][i]=(RED*256)+GREEN;
			#local i=i+1;
		#end
		//#read(fichero,aux1,aux2)
		#local j=j-1;
	#end*/

	//
	//datosHF[0][0] es la esquina inferior izquierda del height field
	//datosHF[altoHF][anchoHF] es la esquina superior derecha del height field
	//
	#declare datosHF=array[altoHF][anchoHF]
	#local j=0;
	#while (j<altoHF)
		#local i=0;
		#while (i<anchoHF)
			#read(fichero,BLUE,GREEN,RED)
			#declare datosHF[j][i]=(RED*256)+GREEN;
			#local i=i+1;
		#end
		//#read(fichero,aux1,aux2)
		#local j=j+1;
	#end
	
	#fclose f
	
#end
